<?php
/*
 Plugin Name: CASTPRO4接続プラグイン
Plugin URI: http://www.castpro4.jp/
Description: Wordpress管理画面から、風俗店向けCMS「CASTPROP4」を利用できるようにします。
Version: 1.1 beta
Author: Digi-ark
Author URI: http://www.castpro4.jp/
License: GPL2
*/

/*  Copyright 2012 Digi-ark (email : info@digi-ark.jp)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
$CASTPRO4_URI='';
define('CASTPRO4_CONNECT_DIR',CP4_CONNECT_DIR.'castpro4_connect/');

/**
 * メインメニュー＆サブメニューフック
 */
//function cp4_connect_menu(){
//	add_submenu_page('options-general.php', 'CASTPRO4 接続設定', 'CASTPRO4 接続設定', 6, dirname(__FILE__).'/options.php');
//
//	add_menu_page('CASTPRO4', 'CASTPRO4', 2, __FILE__, 'cp4_connect_index',CASTPRO4_CONNECT_DIR.'/img/castpro4_icon.png');
//	add_submenu_page( __FILE__, 'キャスト登録','キャスト登録', 6, 'cp4_connect_cast_edit','cp4_connect_cast_edit');
//	add_submenu_page( __FILE__, 'キャスト一覧','キャスト一覧', 6, 'cp4_connect_cast_list','cp4_connect_cast_list');
//	add_submenu_page( __FILE__, '出勤','出勤', 6, 'cp4_connect_cast_schedule','cp4_connect_cast_schedule');
//	add_submenu_page( __FILE__, '出勤タイムライン','出勤タイムライン', 6, 'cp4_connect_cast_schedule_timeline','cp4_connect_cast_schedule_timeline');
//	add_submenu_page( __FILE__, '待ちヒメ','待ちヒメ', 6, 'cp4_connect_machihime','cp4_connect_machihime');
//}
//add_action('admin_menu', 'cp4_connect_menu');

/**
 * プラグインロード時の定数定義
 */
function cp4_connect_addConst($arr){
	$CASTPRO4_URI=get_option('castpro4_url');
	$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;

	if(!empty($CASTPRO4_URI)){
		define('CP4_ROOT',$_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI);
	}
}
add_action('plugins_loaded','cp4_connect_addConst');

/**
 * サブメニュークリック時の動作
 */
function cp4_connect_index(){
	cp4_get_content('index.php');
}
function cp4_connect_cast_list(){
	cp4_get_content('cast_list.php');
}
function cp4_connect_cast_edit(){
	cp4_get_content('cast_edit.php');
}
function cp4_connect_cast_schedule(){
	cp4_get_content('schedule_weekly.php');
}
function cp4_connect_cast_schedule_timeline(){
	cp4_get_content('schedule_timeLine.php');
}
function cp4_connect_machihime(){
	cp4_get_content('plugin_template.php?plugin=machihime,admin');
}
function cp4_checkUserID($user_id){
	return ($user_id=='admin')? 'myshop':$user_id;
}

/**
 * インラインフレーム表示本体 / 設定不足時のメッセージ
 */
function cp4_get_content($fileName){
	$CASTPRO4_URI=get_option('castpro4_url');
	$currentUser=wp_get_current_user();
	$castpro_id=get_user_option('castpro_id',$currentUser->ID);
	$castpro_pw=get_user_option('castpro_passwd',$currentUser->ID);

	//設定不足時
	if(!defined('CP4_ROOT')||empty($castpro_id)||empty($castpro_pw)):
		?>
CONNECT PLUGIN
<h3>CASTPRO4を起動するためには、下記の設定が必要です</h3>
<div style="border: 5px solid #006699; background-color: #FFFFFF; margin: 0.5em; padding: 0.5em;">
	<ol>
		<?php if(empty($CASTPRO4_URI)):?>
        
		<li>CASTPRO4のインストール先を設定するには、<br /> <strong>設定 &raquo;<a href="<?php echo admin_url('options-general.php'); ?>?page=cp4_connect/castpro4_connect/options.php">CASTPRO4 接続設定</a>
		</strong>
		</li>
		<?php endif;
if(empty($castpro_id)||empty($castpro_pw)):?>
		<li>WordpressのユーザーとCASPTOR4のユーザーを関連付けるには、<br /> <strong>プロフィール &raquo;「<a href="<?php echo admin_url('profile.php'); ?>#cp4_connect">CASTPRO4アカウントリンク</a>」
		</strong>
		</li>
		<?php endif;?>
	</ol>
</div>
<?php
exit();
endif;

	//本体ここから
	$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;

	wp_enqueue_script('jquery');
	?>
<style>
#preload {
	font-size: 10px;
	color: #CCCCCC;
	width: 210px;
	height: 30px;
	position: absolute;
	top: 50%;
	left: 50%;
	margin-top: -15px;
	margin-left: -105px;
	z-index: -5;
}

#cp4_frame {
	z-index: 0;
	height:0;
}
</style>
<div>
	<iframe src="" id="cp4_frame" width="100%"></iframe>
	<div id="preload">
		<img src="<?php echo plugin_dir_url(__FILE__); ?>img/loadingAnimation.gif" /> CASTPRO4 CONNECTING...
	</div>
</div>
<script type="text/javascript">
	//jQuery.noConflict();
	var cp4FrameObj=jQuery('#cp4_frame');
	var cp4PreloadObj=jQuery('#preload');
	var cp4FrameType=false;
	var userAgent = navigator.userAgent.toLowerCase();
	var cp4Footerbox;
	var cp4FooterboxH=0;
	var cp4StageHeight=0;
	var cp4FrameH=0;
	var headerHeight=jQuery('#gantry-overrides').outerHeight();
	var mainHeight=jQuery('#wpcontent').innerHeight();

	cp4FrameObj.hide();
	function resizeHeight(iframe) {
		cp4FrameObj.height(0);
		var minHeight=mainHeight-headerHeight;
	
		var scrollH = iframe.contents().find('#contents').height();

		var newHeight=scrollH +100;
		if(newHeight>minHeight){
			cp4FrameH=newHeight;
		}else{
			cp4FrameH=minHeight;
		}
		
		cp4StageHeight=jQuery(window).height();

		iframe.height(cp4FrameH);
	}

	function get_castpro4_content(filename){
		cp4FrameObj.hide();
		//自動ログイン
		jQuery.post( '../../../<?php echo $CASTPRO4_URI;?>/admin/login_pc.php',
			{user:'<?php echo esc_html($castpro_id); ?>',password:'<?php echo esc_html($castpro_pw); ?>'},
			function(dat){
				cp4FrameObj.attr('src','../../../<?php echo $CASTPRO4_URI;?>/admin/pc/'+filename);
			}
		);
	}

	(cp4FrameObj).load(function(){
		var target=cp4FrameObj.contents();

		//表示変換
		target.find('#admin_bg').css({backgroundImage:'none',backgroundColor:'transparent'});
		target.find('#sidebar').css({position:'absolute',top:0,left:0,width:'100%',backgroundImage:'none',backgroundColor:'transparent',backgroundRepeat:'repeat-x',backgroundPosition:'0 -904px',minHeight:'42px',overflow:'hidden'});

		//#sidebar >#accordionの移動
		var sideMenu=target.find('#accordion');
		sideMenu.css({width:'100%',position:'static',marginLeft:'180px'})
			.find('h3[class^=title-]').each(function(){
				var clsName=jQuery(this).attr('class');
				var keyword=clsName.substring(6,clsName.length);
				sideMenu.find('h3.title-'+keyword+',ul.list-'+keyword).wrapAll('<div class="cp4_connect_wrap"></div>');
			});

		//#contents
		var mainContents=target.find('#contents');

		var loginOut=mainContents.find('#loginout');
		loginOut.find('a[href*="php"]').remove();
		loginOut.text((loginOut.text()).replace(/\|/g,""));

		//コンテンツの移動
		sideMenu.before(mainContents.find('h1:eq(0),#loginout'));
		sideMenu.find('ul').css({display:'none'});

		//CSS
		var sidebar=target.find('#sidebar');
		sidebar.find('a').css({color:'#999'});
		sidebar.find('a[href="plugin_template.php?plugin=news,admin"]').hide();
		sidebar.find('ul.list-dashboard').closest('.cp4_connect_wrap').hide();
		sidebar.find('ul.list-support').closest('.cp4_connect_wrap').hide();
		sidebar.find('h1:eq(0)').css({marginLeft:'180px',fontSize:'1em'});
		sidebar.find('#logo a').css({top:'12px',background:'url(<?php echo plugin_dir_url(__FILE__); ?>img/sidebar_logo.gif) 0px 0px no-repeat'});
		sidebar.find('#version').css({top:'27px'});
		mainContents.css({marginTop:'50px',marginLeft:'0'});
		
		cp4Footerbox=mainContents.find('div.footerBox');
		cp4FooterboxH=cp4Footerbox.height();

		// iframe内のheadにcssを追加
		var ihead = target.find('head');
		var cs = target[0].createElement('link')
		cs.href = '<?php echo plugin_dir_url(__FILE__); ?>css/cp4_admin.css';
		cs.type = 'text/css';
		cs.rel = 'stylesheet';
		ihead[0].appendChild(cs);

		//iframe表示、高さ調節
		target.find('body').ready(function(){
			setTimeout(function(){
				resizeHeight(cp4FrameObj);
			},1000);
	
			cp4FrameObj.contents().find('img[src$="ajax-loader.gif"]').each(function(){
				var imgTarget=jQuery(this);
				imgTarget.attr('src',imgTarget.data('origin'));
			});
		});
		cp4FrameObj.show();
	});

	(cp4FrameObj).ready(function(){
		get_castpro4_content('<?php echo $fileName;?>');

		jQuery(window).resize(function(){
			setTimeout(function(){
				resizeHeight(cp4FrameObj);
			},1000);
		});

		jQuery(window).scroll(function(){
			if(cp4StageHeight===void(0)) return ;
			var scrH=jQuery(this).scrollTop()+(cp4StageHeight-(cp4FooterboxH+150));
			scrH=(cp4FrameH-headerHeight>scrH)? scrH:cp4FrameH-headerHeight;
			cp4Footerbox.css({top:scrH});
		});
	});
</script>
<?php
}

/**
 * ユーザープロフィールへのフック
 */
function add_user_castproAccount( $bool ) {
	global $profileuser,$wpdb;
	if ( preg_match( '/^(profile\.php|user-edit\.php)/', basename( $_SERVER['REQUEST_URI'] ) ) ) {
		?>
<h3>
	<span style="display: table-cell; vertical-align: middle; margin: 0; padding-right: 1em;"><img src="<?php echo plugin_dir_url(__FILE__); ?>/img/logo.png" /> </span> <span style="display: table-cell; vertical-align: middle; margin: 0; font-weight: bold;">設定</span><a id="cp4_connect"></a>
</h3>
<table class="form-table" style="border: 1px solid #CCC;">
	<tr>
		<td colspan="2"><strong>[店舗情報の連携]</strong></td>
	</tr>
	<tr>
		<th>CASTPRO4店舗情報との連携</th>
		<td><label><input type="checkbox" name="cp4_enabledShopData" id="cp4_enabledShopData" value="1" <?php if($profileuser->cp4_enabledShopData) echo "checked";?> />連携する</label> <span>※CASTPROアカウントと同名のタグがついた店舗に限ります</span>
		</td>
	</tr>
	<?php if($profileuser->cp4_enabledShopData):
	$cp4_sql="select shopName,leader,type,address,tel,eMail,openClose,area from castpro_shop where shopTag='%s' limit 1;";
	$cp4_sql=sprintf($cp4_sql,cp4_checkUserID($profileuser->castpro_id));
	$cp4_thisShop=$wpdb->get_row($cp4_sql);
	if(is_object($cp4_thisShop))	$cp4_thisShop=$cp4_thisShop;
	else $cp4_thisShop=new stdClass();
	?>
	<tr>
		<th scope="row">店舗名</th>
		<td><label><input type="text" name="cp4_shopName" id="cp4_shopName" value="<?php echo esc_html( $cp4_thisShop->shopName ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">業種</th>
		<td><label><input type="text" name="cp4_type" id="cp4_type" value="<?php echo esc_html( $cp4_thisShop->type ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">地域</th>
		<td><label><input type="text" name="cp4_area" id="cp4_area" value="<?php echo esc_html( $cp4_thisShop->area ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">電話番号</th>
		<td><label><input type="text" name="cp4_tel" id="cp4_tel" value="<?php echo esc_html( $cp4_thisShop->tel ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">営業時間</th>
		<td><label><input type="text" name="cp4_openClose" id="cp4_openClose" value="<?php echo esc_html( $cp4_thisShop->openClose ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">住所</th>
		<td><label><input type="text" name="cp4_address" id="cp4_address" value="<?php echo esc_html( $cp4_thisShop->address ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">連絡用メールアドレス</th>
		<td><label><input type="text" name="cp4_eMail" id="cp4_eMail" value="<?php echo esc_html( $cp4_thisShop->eMail ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">担当者</th>
		<td><label><input type="text" name="cp4_leader" id="cp4_leader" value="<?php echo esc_html( $cp4_thisShop->leader ); ?>" class="regular-text" /> </label>
		</td>
	</tr>
	<?php endif;?>
</table>
<div>&nbsp;</div>
<table class="form-table" style="border: 1px solid #CCC; background-color: #EEE;">
	<tr>
		<td colspan="2"><strong>[CASTPRO4 アカウントリンク]</strong><a id="cp4_connect"></a><span style="color: red; padding-left: 1em;">※Wordpressのユーザー名・パスワードと、使用したいCASTPRO4アカウントが異なる場合のみ設定してください</span></td>
	</tr>
	<tr>
		<th scope="row">USER ID</th>
		<td><label><input type="text" name="castpro_id" id="castpro_id" value="<?php echo esc_html( $profileuser->castpro_id ); ?>" /> </label>
		</td>
	</tr>
	<tr>
		<th scope="row">PASSWORD</th>
		<td><label><input type="password" name="castpro_passwd" id="castpro_passwd" value="" /> <?php echo(empty($profileuser->castpro_passwd))? "未登録です":"登録済みです"; ?> </label>
		</td>
	</tr>
</table>
<?php
	}
	return $bool;
}
add_action( 'show_user_profile', 'add_user_castproAccount' );
add_action( 'edit_user_profile', 'add_user_castproAccount' );

/**
 * ユーザー作成とアカウントリンク
 */
function insert_user_castproAccont($user_id){
	global $wpdb;
	$arr=array();

	//CP4 - ユーザー連携
	$arr['userName']=get_the_author_meta('display_name', $user_id );
	$arr['loginID']=get_the_author_meta('login', $user_id );

	$cp4_pw = sanitize_text_field( $_POST['pass2'] );
	$cp4_pw = wp_filter_kses( $cp4_pw );
	$cp4_pw = _wp_specialchars( $cp4_pw );
	$arr['userPwd']=md5($cp4_pw);

	$arr['permission']=implode(",",array('ALL'));
	$arr['registDate']="NOW()";

	$cp4_userExists=$wpdb->get_var($wpdb->prepare("select count(loginID) as c from castpro_user where loginID='{$arr['loginID']}';"));
	my_log_message($cp4_userExists);
	if((int)$cp4_userExists<1){
		$wpdb->insert( 'castpro_user', $arr, array( '%s', '%s','%s','%s',date('Y-m-d H:i:s') ));
		update_user_meta( $user_id, 'castpro_id', $arr['loginID'] );
		update_user_meta( $user_id, 'castpro_passwd', $cp4_pw );
	}

	//CP4 - 店舗情報
	update_user_meta( $user_id, 'cp4_enabledShopData', false);
}
add_action( 'user_register', 'insert_user_castproAccont', 10, 2 );

/**
 * ユーザー削除とアカウントリンク
 */
function delete_user_castproAccont($user_id){
	global $wpdb;
	$castpro_id=get_user_meta( $user_id, 'castpro_id' );
	if(is_array($castpro_id)&&!empty($castpro_id[0])&&$castpro_id[0]!='admin'){
		$wpdb->delete('castpro_user',array('loginID'=>$castpro_id[0]));
	}
}
add_action( 'delete_user', 'delete_user_castproAccont', 10, 2 );

/**
 * アカウントリンクの保存と保存時フック
 */
function update_user_castproAccount( $user_id, $old_user_data ) {
	global $wpdb;

	//アカウントリンク - アカウント
	$castpro_id=$old_user_data->castpro_id;
	if (isset( $_POST['castpro_id'] ) && $old_user_data->castpro_id != $_POST['castpro_id']) {
		$castpro_id = sanitize_text_field( $_POST['castpro_id'] );
		$castpro_id = wp_filter_kses( $castpro_id );
		$castpro_id = _wp_specialchars( $castpro_id );
		update_user_meta( $user_id, 'castpro_id', $castpro_id );
	}

	//アカウントリンク - パスワード
	$castpro_pw=$old_user_data->castpro_passwd;
	$pass_changedFlag=false;
	if (isset( $_POST['castpro_passwd'] ) && !empty($_POST['castpro_passwd']) && $old_user_data->castpro_passwd != $_POST['castpro_passwd']) {
		$castpro_pw = sanitize_text_field( $_POST['castpro_passwd'] );
		$castpro_pw = wp_filter_kses( $castpro_pw );
		$castpro_pw = _wp_specialchars( $castpro_pw );
		update_user_meta( $user_id, 'castpro_passwd', $castpro_pw );
		$pass_changedFlag=true;
	}

	//CP4側 - アカウント
	$arr=array();
	$arr2=array();
	$cp4_name = sanitize_text_field(urldecode($_POST['display_name']));
	$cp4_name = wp_filter_kses( $cp4_name );
	$cp4_name = _wp_specialchars( $cp4_name );
	$arr['userName']=$cp4_name;
	$arr2[]='%s';

	if(!empty($_POST['pass2'])&&!$pass_changeFlag){
		$cp4_pw = sanitize_text_field( $_POST['pass2'] );
		$cp4_pw = wp_filter_kses( $cp4_pw );
		$cp4_pw = _wp_specialchars( $cp4_pw );
		$arr['userPwd']=md5($cp4_pw);
		$arr2[]='%s';
		update_user_meta( $user_id, 'castpro_passwd', $cp4_pw);
	}
	$wpdb->update( 'castpro_user', $arr, array( 'loginID' => $old_user_data->user_login ), $arr2,array('%s'));

	//CP4 - 店舗 設定をするかどうか
	$arr=$arr2=array();
	$cp4_enabledSD=false;
	if(isset($_POST['cp4_enabledShopData'])){
		if( $_POST['cp4_enabledShopData']==1 )	$cp4_enabledSD=true;
	}
	update_user_meta( $user_id, 'cp4_enabledShopData', $cp4_enabledSD);

	//CP4 - 店舗情報
	if($cp4_enabledSD&&!empty($_POST['cp4_shopName'])){
		//データのセット
		$tmp['shopName']=wp_filter_kses($_POST['cp4_shopName']);
		$tmp['leader']=wp_filter_kses($_POST['cp4_leader']);
		$tmp['type']=wp_filter_kses($_POST['cp4_type']);
		$tmp['address']=wp_filter_kses($_POST['cp4_address']);
		$tmp['tel']=wp_filter_kses($_POST['cp4_tel']);
		$tmp['eMail']=wp_filter_kses($_POST['cp4_eMail']);
		$tmp['openClose']=wp_filter_kses($_POST['cp4_openClose']);
		$tmp['area']=wp_filter_kses($_POST['cp4_area']);

		$arr2=array('%s','%s','%s','%s','%s','%s','%s','%s');
		$cp4_sql="select count(shopTag) from castpro_shop where shopTag='%s';";
		$cp4_sql=sprintf($cp4_sql,cp4_checkUserID($castpro_id));
		$cp4_thisShop=$wpdb->get_var($wpdb->prepare($cp4_sql));
		if((int)$cp4_thisShop<1){
			//新規
			$arr['shopTag']=$castpro_id;
			$arr=$arr+$tmp+array('registDate'=>"NOW()");
			$arr2=array('%s','%s','%s','%s','%s','%s','%s','%s','%s','NOW()');
			$wpdb->insert( 'castpro_shop', $arr, $arr2);
		}else{
			//更新
			$arr=$tmp;
			$wpdb->update( 'castpro_shop', $arr, array( 'shopTag' => cp4_checkUserID($castpro_id) ), $arr2,array('%s'));
		}
	}
}
add_action( 'profile_update', 'update_user_castproAccount', 10, 2 );

/**
 * ダッシュボードウィジェット -コンテンツ
 */
function cp4_connect_dashboard_widget_function() {
	if(!defined('CP4_ROOT')){
		echo '<a href="admin.php?page=castpro4_connect/main.php">設定</a>が完了していないため、表示できません';
		return;
	}
	?>
<div id="cp4_connect_dashboard"></div>
<script>
jQuery.get('<?php echo plugin_dir_url(__FILE__); ?>dashboard.php',function(data){
	var cp4_dashboard=jQuery("#cp4_connect_dashboard");
	cp4_dashboard.html(data);
	var cp4_baseColor="";
	cp4_dashboard.find('#cp4_connect_machi').mouseover(function(){
		cp4_baseColor=cp4_dashboard.find('img.machi').css('borderColor');
		cp4_dashboard.find('img.machi').css('borderColor','#D54E21');
	}).mouseout(function(){
		cp4_dashboard.find('img.machi').css('borderColor',cp4_baseColor);
	});

	cp4_dashboard.find('#cp4_connect_working').mouseover(function(){
		cp4_dashboard.find('#cp4_connect_nowCast').css('backgroundColor','#6699CC');
	}).mouseout(function(){
		cp4_dashboard.find('#cp4_connect_nowCast').css('backgroundColor','transparent');
	});
});
</script>
<?php
}

/**
 * ダッシュボードウィジェット -表示フック
 */
function cp4_connect_add_dashboard_widgets() {
	wp_add_dashboard_widget('cp4_connect_dashboard_widget', '<img src="'.plugin_dir_url(__FILE__).'img/castpro4_icon_s.png" />CASTPRO4', 'cp4_connect_dashboard_widget_function');
}
add_action('wp_dashboard_setup', 'cp4_connect_add_dashboard_widgets' );

/**
 * デバッグメッセージをログファイルに出力する関数
 *
 * @param string $output  出力したい文字列
 * @param string $path    出力先のパス（未指定時はテンプレートと同じディレクトリのlog.txt）
 * @see [030] WordPress のデバッグ | WordPress experiment – twentyten customize- http://experiment.street-square.com/2010/10/04/debug/#more-923
 */
function my_log_message($output, $path = null) {
	$str = var_export($output, true);
	$path = isset($path) ? $path : dirname(__FILE__) . '/log.txt';
	$fp = fopen($path, 'a');
	fwrite($fp, "{$str}\n");
	fclose($fp);
}
?>