<?php 
class bannerItem extends WP_Widget {

	function bannerItem() {	
    	parent::WP_Widget(false, $name = 'CASTPRO -バナー- ');
    }
	
    function widget($args, $instance) {
	
        extract($args);
		
		global $options;		
		$title = apply_filters('widget_title',$instance['title']);	
    	?>
        <?php echo $before_widget; ?>
        <?php if($title){ echo $before_title.$title.$after_title; } ?>
        <div class="widget_frame">
        <ul class="bnr_lists clearfix">
        <?php
	$bnrlists = $options['bnr_space'];
	
	if(is_array($bnrlists)) {
	
		foreach($bnrlists as $bnr_row => $bnr_val){
		
			if(!empty($bnr_val['image'])){
			
				$bnr_image = wp_get_attachment_image_src($bnr_val['image'],'full', false);						
				$image_data = "<img src=\"".$bnr_image[0]."\" />";		
						
				if($bnr_val['target'] == '_blank'){
				
					$image_target = "target=_blank";
				
				}
				
				if($bnr_val['url']){
				
					$image_data = "<a href=\"".$bnr_val['url']."\" ".$image_target.">".$image_data."</a>";
				
				}
						
				echo  "<li>".$image_data."</li>";
						
			}
			
		}
	
	}
	?>
    </ul>
    </div>
        <?php echo $after_widget; ?>
        <?php
    }
	
    function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
        return $instance;
    }
	
    function form($instance) {
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($instance['title']); ?>" /></p>
<?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("bannerItem");'));
?>