<?php 
class sidediaryItem extends WP_Widget {

	function sidediaryItem() {
	
    	parent::WP_Widget(false, $name = 'CASTPRO 写メ日記');
		
    }
	
    function widget($args, $instance) {
	
		extract($args);
		
		
		
		$title = apply_filters( 'widget_title', $instance['title'] ); ?>
		<?php echo $before_widget; ?>
		<?php if($title){ echo $before_title.$title.$after_title; } ?>
        <div class="widget_frame">
		<iframe src="<?php echo $instance['diary_url']; ?>" frameborder="0" <?php if($instance['height']) echo "height=\"".$instance['height']."\""; ?>></iframe>
        </div>
		<?php echo $after_widget; ?> 
		<?php
    }
	
    function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['diary_url'] = strip_tags($new_instance['diary_url']);
		$instance['height'] = strip_tags($new_instance['height']);
		
		return $instance;
    }
	
    function form($instance) {
	
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('写メ日記');
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
          
        <p><label for="<?php echo $this->get_field_id('diary_url'); ?>"><?php _e('URL'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('diary_url'); ?>" name="<?php echo $this->get_field_name('diary_url'); ?>" type="text" value="<?php echo esc_attr($instance['diary_url']); ?>" /></p>
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('高さ'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($instance['height']); ?>" /></p>
        <?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("sidediaryItem");'));
?>