<?php 
class freeareaItem extends WP_Widget {

	function freeareaItem(){
    	parent::WP_Widget(false, $name = 'CASTPRO -フリースペース- ');
    }
	
    function widget($args, $instance){
	
		global $wp_query;
		
        extract($args);
		$title = apply_filters('widget_title',$instance['title']);	   
	   	?>
		<?php echo $before_widget; ?>
		<?php if($title) echo $before_title.$title.$after_title; ?>
        <div class="widget_frame" <?php if($instance['height'] && wp_is_mobile() == false) echo "style=\"height:".$instance['height']."px; overflow-y:scroll;\""; ?>>
		<div class="free_space">
		<?php
		$freespace_widget_query = new WP_Query(array('page_id' => $instance['page_id']));		
		while($freespace_widget_query->have_posts()) : $freespace_widget_query->the_post();
		?> 
		<?php the_content(); ?>
		<?php endwhile; ?>
		<?php wp_reset_postdata(); ?>
		</div>
        </div>
		<?php echo $after_widget; ?> 
		<?php
    }

    function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['page_id'] = strip_tags($new_instance['page_id']);
		$instance['num'] = strip_tags($new_instance['num']);
		$instance['height'] = strip_tags($new_instance['height']);
		
		return $instance;
    }
	
    function form($instance) {
    ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($instance['title']); ?>" /></p>        
        <p><label for="<?php echo $this->get_field_id('page_id'); ?>"><?php _e('ページ'); ?></label></p>
        <p>
         <select name="<?php echo $this->get_field_name('page_id'); ?>" id="<?php echo $this->get_field_id('page_id'); ?>">
        <?php
		$freespace_pagelists_query = new WP_Query(array('post_type' => 'page','posts_per_page' => -1));		
		while($freespace_pagelists_query->have_posts()) : $freespace_pagelists_query->the_post();
		?>
        <option value="<?php echo  esc_attr(get_the_ID()); ?>" <?php if(esc_attr($instance['page_id']) == get_the_ID()) echo "selected=\"selected\""; ?>><?php echo esc_attr(get_the_title()); ?></option>
		<?php endwhile; ?>
		<?php wp_reset_postdata(); ?>
       	</select>
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('高さ'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($instance['height']); ?>" /></p>
        <?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("freeareaItem");'));