<?php 
class newfaceItem extends WP_Widget {
	
	function newfaceItem() {
		parent::WP_Widget(false, $name = 'CASTPRO -新人- ');
	}
		
	function widget($args, $instance) {
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		$num = apply_filters( 'widget_num', $instance['num'] );
		$CASTPRO4_URI=get_option('castpro4_url');
		$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;		
		require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');
		$options = get_option( 'theme_options' );			
		
		global $CASTPRO,$gc,$plugin,$dateforShow,$CP_pluginList,$CP_SQL,$options;
	?>
	<?php echo $before_widget; ?>
	<?php if($title){ echo $before_title.$title.$after_title; } ?>
    <div class="widget_frame" <?php if($instance['height'] && wp_is_mobile() == false){ echo "style=\"height:".$instance['height']."px; overflow-y:scroll;\""; } ?>>
	<ul id="side_newcast_list" class="cast_list_frame clearfix">
	<?php
	
	$gc_newface = new girlsCollection($CP_SQL);
	
	//空のスケジュールを用意
	$emptySchedule=new schedule_output();
	
	/**新人キャスト出力**/
	
	$gc_newface->get_girlsCollection("newface=1&order=girlOrder&max=".$num);	//データを取得
	
	/**待ちヒメプラグインを設定**/
	$plugin=$CP_pluginList->getPluginByName('machihime');	//プラグインをアクティブに
		
	//キャストデータループ
	if($gc_newface->have_girls()):while($gc_newface->have_girls()):
	$girl_newface = new collection($gc_newface->the_girl());	//1人分のデータを取り出す
	
	$schData=$girl_newface->getItem('schedule');	//スケジュールデータを取り出す
	
	
	$schData=$schData[0]; //本日分のデータが入っている配列を取り出す
	if(empty($schData)) $schData=$emptySchedule;//スケジュールが無ければ空のスケジュールをセットする
	
	//画像のパスをセット
	$imgPath=sprintf($CASTPRO->get_property('girlsDataPath'),$girl_newface->getItem('girlID'));
	
	//一言コメントをセット
	$comment=new collection($gc_newface->get_onlyGirlData('一言コメント',false));
	
	//入店日をセット
	$tmp=$gc_newface->get_onlyGirlData('入店日',false);
	
	//待ちヒメステータスを取得
	$thisState=$plugin->get_status($girl_newface->getItem('girlID'),$schData);
	?>
	<li>
	<div class="cast_frame">
	<a href="<?php echo home_url('profile'); ?>?gid=<?php $girl_newface->echoItem('girlID');?>">
	<div class="cast_thumb">
	<img src="<?php echo $imgPath."thumb.jpg"; ?>" alt="<?php $girl_newface->echoItem('name');?>" />
	</div>
	<div class="cast_section sub_color">
	<div class="cast_name"><?php $girl_newface->echoItem('name');?>(<?php $girl_newface->echoItem('age');?>)
    <?php if($options['cast_flag']['cast_flag_newface_icon'] == true){ ?>    
    <span class="newface_icon"><?php if($girl_newface->getItem('newface') == 1){ ?><img src="<?php bloginfo('stylesheet_directory'); ?>/images/ico_newface.gif" alt="NEW FACE" /><?php } ?></span>
    <?php } ?>
    </div>
	<div class="cast_size">T<?php $girl_newface->echoItem('height');?> B<?php $girl_newface->echoItem('B');?> (<?php $girl_newface->echoItem('cup');?>) W<?php $girl_newface->echoItem('W');?> H<?php $girl_newface->echoItem('H');?></div>
	<div>
	<span class="entry_date">入店日:<?php echo str_replace("-","/",substr($girl_newface->getItem('registDate'),5,5));?></span></div>
    <?php if($options['cast_flag']['cast_flag_comment'] == true){ ?>
	<div class="cast_comment">
	<?php $comment->echoItem('value');?>
	</div>
    <?php } ?>
	</div>
	</a>
	</div>
	</li>
	<?php
	endwhile;endif;
	$gc_newface->clear_girlsCollection();
	$comment=null;
	unset($comment);
	/**END of 新人キャスト出力**/
	?>
	</ul>
    </div>
	<?php echo $after_widget; ?>
	<?php
		}
		
		function update($new_instance, $old_instance){
		
			$instance = $old_instance;
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['num'] = strip_tags($new_instance['num']);
			$instance['height'] = strip_tags($new_instance['height']);
			return $instance;
		}
		
		function form($instance) {
		
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('新人キャスト');
		$castnum = isset($instance['num']) ? $instance['num'] : '5';
		?>
			<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
			<p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
			<p><label for="<?php echo $this->get_field_id('num'); ?>"><?php _e('表示人数'); ?></label></p>
			<p><input class="widefat" id="<?php echo $this->get_field_id('num'); ?>" name="<?php echo $this->get_field_name('num'); ?>" type="text" value="<?php echo esc_attr($castnum); ?>" /></p>
            <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('高さ'); ?></label></p>
			<p><input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($instance['height']); ?>" /></p>
		<?php
		}
	}
add_action('widgets_init', create_function('', 'return register_widget("newfaceItem");'));
?>