<?php 
class pickupItem extends WP_Widget {

	function pickupItem() {
    	parent::WP_Widget(false, $name = 'CASTPRO -PICKUP- ');
    }
	
    function widget($args, $instance){
		
		extract($args);
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		$CASTPRO4_URI=get_option('castpro4_url');
		$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;		
		require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');
		global $CASTPRO,$CP_SQL;
		
		if($instance['num']){		
			$pcknum = $instance['num'];		
		}else{
			$pcknum = -1;
		}
		?>
		<?php echo $before_widget; ?>
		<?php if($title){ echo $before_title.$title.$after_title; } ?>
        <div class="widget_frame">
		<div class="flexslider">
		<ul class="slides">
		<?php
		$gc_side=new girlsCollection($CP_SQL);
		$gc_side->get_girlsCollection("&categoryAndValue=ピックアップ:Pickup - トップページ&max=".$instance['num']);
		$gc_side->shuffle();
		if($gc_side->have_girls()):while($gc_side->have_girls()):
		$girl_side=new collection($gc_side->the_girl());
		//画像のパスをセット
		$imgPath_side=sprintf($CASTPRO->get_property('girlsDataPath'),$girl_side->getItem('girlID'));
		//$imgList_Lに今のキャストのLサイズ画像が取り出されます
		$imgList_L=$gc_side->get_girls_image($imgPath_side,'pc_l',$CASTPRO->get_property('noPhoto_l'));
				
		?>
		<li>
		<a href="<?php echo home_url('profile'); ?>?gid=<?php $girl_side->echoItem('girlID');?>"><img src="<?php echo $imgList_L[0]['fileName']; ?>" alt="<?php $girl_side->echoItem('name');?>" />
		<div class="flex-caption cast_section sub_color"><?php $girl_side->echoItem('name');?>(<?php $girl_side->echoItem('age');?>)
		B<?php $girl_side->echoItem('B');?>(<?php $girl_side->echoItem('cup');?>) W<?php $girl_side->echoItem('W');?> H<?php $girl_side->echoItem('H');?></div>
		</a>
		</li>
		
		<?php
		endwhile;endif;
		
		$gc_side->clear_girlsCollection();
		$gc_side=null;
		$imgPath_side=null;
		unset($imgPath_side);
		unset($gc_side);
		unset($girl_side);
		/**END of PICKUP出力**/
		?>
		</ul>
		</div>
        </div>
		<?php echo $after_widget; ?> 
		<?php
	}
	
	function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['num'] = strip_tags($new_instance['num']);
		
		return $instance;
		
	}
		
	function form($instance) {
	
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('PICKUP CAST');
		$castnum = isset($instance['num']) ? $instance['num'] : '5';
	?>
			<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
			<p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
            <p><label for="<?php echo $this->get_field_id('num'); ?>"><?php _e('表示件数'); ?></label></p>
			<p><input class="widefat" id="<?php echo $this->get_field_id('num'); ?>" name="<?php echo $this->get_field_name('num'); ?>" type="text" value="<?php echo esc_attr($castnum); ?>" /></p>
	<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("pickupItem");'));
?>