<?php 
class magItem extends WP_Widget {

	function magItem() {	
    	parent::WP_Widget(false, $name = 'CASTPRO -メールマガジン- ');
    }
	
    function widget($args, $instance) {
	
        extract($args);
		
		$CASTPRO4_URI=get_option('castpro4_url');
		$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;		
		require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');
		global $CASTPRO,$CP_SQL,$options;		
		$title = apply_filters('widget_title',$instance['title']);
		$read = apply_filters('widget_title',$instance['read']);
		
		if(!is_page('mailmagazine')){
		
		
    	?>
        <?php echo $before_widget; ?>
        <?php if($title){ echo $before_title.$title.$after_title; } ?>
        <div class="widget_frame">
        <form name="generalMailMagazine_members_form" id="side_generalMailMagazine_members_form" action="<?php echo $CASTPRO->get_property('plugin_path')."generalMailMagazine/request_membersForm.php"; ?>" method="post">
       <?php if($read){ ?>
     <div class="mag_caption">
     <?php echo $read; ?>
     </div>
     <?php } ?>
     
     <?php $magshopID = $CASTPRO->get_shopList('shopID'); ?>
	<input type="hidden" name="shopID" id="shopID" value="<?php echo $magshopID[0]["shopID"]; ?>" />
	

    <div class="mag_mail_input">
    
    <div class="field row">
	<label id="mag_shop" for="generalMailMagazine_members_address">メールアドレス</label><input name="generalMailMagazine_members_address" type="text" class="inputtext text" id="generalMailMagazine_members_address" size="" value="" />
    </div>
    </div>
    
    <div class="mag_select_flag">
    <ul>
    <li class="field"><label class="radio checked" for="flag1"><input name="generalMailMagazine_config_subscribeFlag" id="flag1" type="radio" value="1" checked="checked" /><span></span> 登録</label>   </li>
    <li class="field"><label class="radio" for="flag0"><input name="generalMailMagazine_config_subscribeFlag" id="flag0" type="radio" value="0" /><span></span> 解除</label></li>
    </ul>
    </div>
    
    <div class="submit">
	<input type="submit" value="送信" class="generalMailMagazine_members_button btn <?php echo $options['button']; ?> <?php echo $options['button_type']; ?>" />
    </div>
</form>
    </div>
    
        <?php echo $after_widget;
		
		}
    }
	
    function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['read'] = strip_tags($new_instance['read']);
        return $instance;
    }
	
    function form($instance) {
	
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('メールマガジン');
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
        
        <p><label for="<?php echo $this->get_field_id('read'); ?>"><?php _e('テキスト'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('read'); ?>" name="<?php echo $this->get_field_name('read'); ?>" type="text" value="<?php echo esc_attr($instance['read']); ?>" /></p>
<?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("magItem");'));
?>