<?php 
class newsItem extends WP_Widget {

	function newsItem() {	
				
	   	parent::WP_Widget(false, $name = 'CASTPRO -ニュース- ');
    }
	
    function widget($args, $instance){
	
		global $wp_query;		
        extract($args);
		$title = apply_filters('widget_title',$instance['title']);
	   	?>
		<?php echo $before_widget; ?>
		<?php if($title) echo $before_title.$title.$after_title; ?>
        <div class="widget_frame" <?php if($instance['height'] && wp_is_mobile() == false) echo "style=\"height:".$instance['height']."px; overflow-y:scroll;\""; ?>>
		<dl class="news_wrap">
		<?php
		$news_widget_query = new WP_Query(array('cat' => $instance['cat_id'],'posts_per_page' => $instance['num']));
		while($news_widget_query->have_posts()) : $news_widget_query->the_post();
		?> 		
        <?php $news_thumb = get_postimage($news_widget_query->post); ?>
        <?php if($news_thumb && $instance['image_flag'] == 'true'){ ?>
        <dt class="news_thumb" style="width:<?php echo $instance['image_width']; ?>px; height:<?php echo $instance['image_width']; ?>px;">
        <a href="<?php echo get_permalink($news_widget_query->post->ID); ?>"><img src="<?php echo $news_thumb['url']; ?>" width="<?php echo $instance['image_width']; ?>" /></a>
        </dt>
        <dd class="news_section" style="padding-left:<?php echo($instance['image_width'] + 4); ?>px;">
       	<h4 class="news_title"><a href="<?php echo get_permalink($news_widget_query->post->ID); ?>"><?php the_title(); ?></a></h4>
        
        <?php if($instance['date_flag'] == 'true' || $instance['catname_flag'] == 'true'){ ?>
        
        <p><?php if($instance['date_flag'] == 'true'){ echo get_the_time('Y/m/d H:i')."&nbsp;"; } if($instance['catname_flag'] == 'true'){ echo get_cat_name($instance['cat_id']); } ?></p>        
        <?php } ?>       
        
        <?php }else{ ?>
        <dt>
        <h4 class="news_title"><a href="<?php echo get_permalink($news_widget_query->post->ID); ?>"><?php the_title(); ?></a></h4>
        <?php if($instance['date_flag'] == 'true' || $instance['catname_flag'] == 'true'){ ?>
        
        <p><?php if($instance['date_flag'] == 'true'){ echo get_the_time('Y/m/d H:i')."&nbsp;"; } if($instance['catname_flag'] == 'true'){ echo get_cat_name($instance['cat_id']); } ?></p>        
        <?php } ?>
        </dt>
        <dd>
		<?php } ?>
        <?php if($args['id'] != 'footerwidgetarea_right' && $args['id'] != 'footerwidgetarea_left' && $instance['content_flag'] == 'true'){ ?>
		<div class="news_content">
        <?php if($instance['word_count'] > 0){ ?>
		<?php echo mb_strimwidth(strip_tags(get_the_content()), 0, $instance['word_count'], __("…"),'utf8'); ?>
        <?php }else{ ?>
        <?php the_content(); ?>
        <?php } ?>
        </div>
        <?php } ?>
		</dd>  
		<?php endwhile; ?>
		<?php wp_reset_postdata(); ?>
		</dl>
        </div>
		<?php echo $after_widget; ?> 
		<?php
    }

    function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['cat_id'] = strip_tags($new_instance['cat_id']);
		$instance['num'] = strip_tags($new_instance['num']);
		$instance['height'] = strip_tags($new_instance['height']);
		$instance['image_width'] = strip_tags($new_instance['image_width']);
		$instance['image_flag'] = strip_tags($new_instance['image_flag']);
		$instance['content_flag'] = strip_tags($new_instance['content_flag']);
		$instance['date_flag'] = strip_tags($new_instance['date_flag']);
		$instance['catname_flag'] = strip_tags($new_instance['catname_flag']);
		$instance['word_count'] = strip_tags($new_instance['word_count']);
		
		return $instance;
    }
	
    function form($instance) {
		
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : 'NEWS';
		$image_width = isset($instance['image_width']) ? $instance['image_width'] : '80';
		$image_flag = isset($instance['image_flag']) ? $instance['image_flag'] : 'true';
		$content_flag = isset($instance['content_flag']) ? $instance['content_flag'] : 'true';
		$date_flag = isset($instance['date_flag']) ? $instance['content_flag'] : 'true';
		$catname_flag = isset($instance['catname_flag']) ? $instance['catname_flag'] : 'true';
		$news_num = isset($instance['num']) ? $instance['num'] : '5';
		
		$image_width_lists = array('40','60','80','100');
		
    ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>        
        <p><label for="<?php echo $this->get_field_id('cat_id'); ?>"><?php _e('カテゴリー'); ?></label></p>
        <p><?php $news_cats = get_terms('category',array('hide_empty' => false)); ?>
        <select name="<?php echo $this->get_field_name('cat_id'); ?>" id="<?php echo $this->get_field_id('cat_id'); ?>">
        <?php foreach($news_cats as $news_cat){ ?>
        <option value="<?php echo $news_cat->term_id; ?>" <?php if(esc_attr($instance['cat_id']) == $news_cat->term_id) echo "selected=\"selected\""; ?>><?php echo $news_cat->name; ?></option>
        <?php } ?>
        </select>
        
        
        <p><label for="<?php echo $this->get_field_id('image_width'); ?>"><?php _e('画像サイズ'); ?></label></p>       
        <p>
        <select name="<?php echo $this->get_field_name('image_width'); ?>" id="<?php echo $this->get_field_id('image_width'); ?>">
        <?php foreach($image_width_lists as $image_width_list){ ?>
        <option value="<?php echo esc_attr($image_width_list); ?>" <?php if(esc_attr($instance['image_width']) == $image_width_list) echo "selected=\"selected\""; ?>><?php echo $image_width_list.__('px'); ?></option>
		<?php } ?>
        </select></p>
        
        <p><?php _e('表示設定'); ?></p>
        <p>
        <input id="<?php echo $this->get_field_id('image_flag'); ?>" name="<?php echo $this->get_field_name('image_flag'); ?>" type="checkbox" value="true" <?php checked($image_flag,'true'); ?> /><label for="<?php echo $this->get_field_id('image_flag'); ?>"><?php _e('画像'); ?></label>
        
     
        <input id="<?php echo $this->get_field_id('date_flag'); ?>" name="<?php echo $this->get_field_name('date_flag'); ?>" type="checkbox" value="true" <?php checked($date_flag,'true'); ?> /><label for="<?php echo $this->get_field_id('date_flag'); ?>"><?php _e('日付'); ?></label>
        
        <input id="<?php echo $this->get_field_id('catname_flag'); ?>" name="<?php echo $this->get_field_name('catname_flag'); ?>" type="checkbox" value="true" <?php checked($catname_flag,'true'); ?> /><label for="<?php echo $this->get_field_id('catname_flag'); ?>"><?php _e('カテゴリー名'); ?></label>
        
       <input id="<?php echo $this->get_field_id('content_flag'); ?>" name="<?php echo $this->get_field_name('content_flag'); ?>" type="checkbox" value="true" <?php checked($content_flag,'true'); ?> /><label for="<?php echo $this->get_field_id('content_flag'); ?>"><?php _e('本文'); ?></label></p>
        
        <p><?php _e('本文文字数'); ?></p>
         <p><input class="widefat" id="<?php echo $this->get_field_id('word_count'); ?>" name="<?php echo $this->get_field_name('word_count'); ?>" type="text" value="<?php echo esc_attr($instance['word_count']); ?>" /></p>
        
        <p><label for="<?php echo $this->get_field_id('num'); ?>"><?php _e('表示件数'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('num'); ?>" name="<?php echo $this->get_field_name('num'); ?>" type="text" value="<?php echo esc_attr($news_num); ?>" /></p>
        
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('高さ'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($instance['height']); ?>" /></p>
        <?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("newsItem");'));