<?php 
class rankingItem extends WP_Widget {

	function rankingItem() {
    	parent::WP_Widget(false, $name = 'CASTPRO -ランキング- ');
    }
	
    function widget($args, $instance){
	
        extract($args);
		
        $title = apply_filters( 'widget_title', $instance['title'] );
       	$CASTPRO4_URI = get_option('castpro4_url');
	    $CASTPRO4_URI = (strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;		
		require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');
		
	    $options = get_option( 'theme_options' );
		
        global $CASTPRO,$CP_SQL;
		
		?>
		<?php echo $before_widget; ?>
		<?php if($title){ echo $before_title.$title.$after_title; } ?>
        <div class="widget_frame">
		<?php
			/** ランキング一覧出力 **/
			$gc_ranking=new girlsCollection($CP_SQL);
			$rankingList=$gc_ranking->get_rankingAll();
			$ranknum = 1;
			foreach($rankingList as $value):
			
			/**1ランキング出力**/
			$ranking=$gc_ranking->get_ranking($value['rankingID'],$instance['num']);//ランキングIDを指定してgirlsCollection::girlsCollectionを更新、ランキング関連データを取り出す
		?>         
		<div class="rank_title clearfix">
		<h4><span class="arrow">◆<?php echo $ranking[0]['label']?>ランキング</span></h4>
		<?php if(!is_null($ranking[0]["girlID"])){ ?><div class="rank_update"><?php echo date('Y/n/j H:i',strtotime($ranking[0]['updateDate'])); ?> 更新</div><?php } ?>
		</div>			 
		<ul class="cast_ranking cast_list_frame clearfix">
		<?php
		if(is_null($ranking[0]["girlID"])){ echo "<li>只今集計中です</li>"; }	
		//キャストデータループ
		if($gc_ranking->have_girls()):while($gc_ranking->have_girls()):
		$girl=new collection($gc_ranking->the_girl());	//1人分のデータを取り出す
		if($girl->getItem('girlID')=="") continue;
		//画像のパスをセット
		$imgPath=sprintf($CASTPRO->get_property('girlsDataPath'),$girl->getItem('girlID'));
		?>
		<li>
		<div class="cast_frame">
		<a href="<?php echo home_url('profile'); ?>?gid=<?php $girl->echoItem('girlID');?>">
		<div class="cast_thumb"><img src="<?php echo $imgPath."thumb.jpg"; ?>" alt="<?php $girl->echoItem('name');?>" /></div>
		<div class="cast_section sub_color">
		<div class="cast_name"><span class="ranking_<?php echo $ranking[$gc_ranking->girls_count()-1]['rankingOrder']; ?>"><?php echo $ranking[$gc_ranking->girls_count()-1]['rankingOrder']."位"; ?></span>
		<?php $girl->echoItem('name');?>(<?php $girl->echoItem('age');?>)
        </div>
		<div class="cast_size">T<?php $girl->echoItem('height');?> B<?php $girl->echoItem('B');?>(<?php $girl->echoItem('cup');?>) W<?php $girl->echoItem('W');?> H<?php $girl->echoItem('H');?></div>
		<div class="cast_comment"><?php echo $ranking[$gc_ranking->girls_count()-1]['rankComment'];?></div>
		</div>
		</a>
		</div>
		</li>
		<?php
		endwhile; endif;
		$gc_ranking->clear_girlsCollection();
		
		$comment=null;
		unset($comment);
		/**END of 1ランキング出力**/
		?>
		</ul>
		<?php
		$ranknum++;			
		endforeach;
		
		$gc_ranking->clear_girlsCollection();
		$gc_ranking=null;
		unset($gc_ranking);
		unset($girl);
				
		/**END of ランキング一覧出力**/
		?>
        </div>
		<?php echo $after_widget; ?> 
	<?php
    	}
	
		function update($new_instance, $old_instance) {
			$instance = $old_instance;
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['num'] = strip_tags($new_instance['num']);
			
			return $instance;
		}
		
		function form($instance) {
		
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('ランキング');

	?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
		
		<p><label for="<?php echo $this->get_field_id('num'); ?>"><?php _e('表示人数'); ?></label></p>
		<p><input class="widefat" id="<?php echo $this->get_field_id('num'); ?>" name="<?php echo $this->get_field_name('num'); ?>" type="text" value="<?php echo esc_attr($instance['num']); ?>" /></p>
	<?php
		}
}
add_action('widgets_init', create_function('', 'return register_widget("rankingItem");'));
?>