<?php 
class scheduleItem extends WP_Widget {

		function scheduleItem() {
			parent::WP_Widget(false, $name = 'CASTPRO -出勤スケジュール- ');
		}
		
		function widget($args, $instance){
		
		
			extract( $args );		
			$title = apply_filters( 'widget_title', $instance['title'] );		
			$CASTPRO4_URI=get_option('castpro4_url');		
			$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;
			require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');		
			$options = get_option( 'theme_options' );
			
			global $CASTPRO,$gc_sch,$plugin,$dateforShow,$CP_pluginList,$CP_SQL,$options;
	
		/*
		 * ウィジェット - 出勤
		 */
	
		$gc_sch=new girlsCollection($CP_SQL);
		$gc_sch->set_timeDiffAtDate($CASTPRO->get_property('dateShift')); //日付切り替え時間の指定
		
		//指定のクエリを作成
		if(isset($_GET))	$gc_sch->girlsQuery->create_queryFromGET($_GET);
	
		/**スケジュール出力**/
		$dateforShow=$gc_sch->get_timeDiffAtDate();	//日付(時差を考慮した日付:getdateの戻り値が入る)
	
		//並び順を指定
		//castpro_orderByCast();//並び順をキャスト順に
		castpro_orderBySchedule();//並び順を出勤順に
	
		//プロフィールデータをセット
		
		$gc_sch->get_girlsCollection($gc_sch->girlsQuery->get_queryText()."&date={$dateforShow['year']}/{$dateforShow['mon']}/{$dateforShow['mday']}&max=-1");
	
		//プロフィールデータにスケジュールをセット
		$gc_sch->get_schedule("date={$dateforShow['year']}/{$dateforShow['mon']}/{$dateforShow['mday']}");
	
		/**待ちヒメプラグインを設定**/
		$plugin=$CP_pluginList->getPluginByName('machihime');	//プラグインをアクティブに
	
		/** 待ちヒメの人数集計 **/
		$m_CountAll=$plugin->get_statusNum();//全ての待ちヒメ人数をカウント
		$m_Count=$plugin->get_statusNum(1);//待ちヒメのコード1をカウント
		
		if($plugin->defaultStatus==1){//待ちヒメのデフォルトコードが1なら
			//登録されているコード1の数-(表示するキャスト数-その他の待ちヒメの数)
			$m_Count+=($cast_Count-$m_CountAll);
		}
		
		/** End of 待ちヒメの人数集計 **/
	
		//$gc_sch->get_girlsCollection()で取得したのキャスト一覧を元に、待ちヒメステータスを取得
		$plugin->set_status($gc_sch->get_girlsCollectionArr());
	?>
	<?php echo $before_widget; ?>
    
	<?php if($title){ echo $before_title.$title.$after_title; } ?>
    <div class="widget_frame" <?php if($instance['height']) echo "style=\"height:".$instance['height']."px; overflow-y:scroll;\""; ?>>
    <div class="clearfix">
	<div class="left"><?php echo date("m月d日 H時i分");?>現在</div><div class="right">本日の出勤:<span class="number text_pink"><?php echo $gc_sch->girls_allLength();?></span>名</div>
	</div>
	<ul id="top_schedule_list" class="cast_list_frame clearfix">
	<?php
	//空のスケジュールを用意
	$emptySchedule=new schedule_output();
	//キャストデータループ
	if($gc_sch->have_girls()):while($gc_sch->have_girls()):
	$girl_sch=new collection($gc_sch->the_girl());	//1人分のデータを取り出す
	
	$schData=$girl_sch->getItem('schedule');	//スケジュールデータを取り出す
	$schData=$schData[0]; //本日分のデータが入っている配列を取り出す
	if(empty($schData)) $schData=$emptySchedule;//スケジュールが無ければ空のスケジュールをセットする
	
	//画像のパスをセット
	$imgPath=sprintf($CASTPRO->get_property('girlsDataPath'),$girl_sch->getItem('girlID'));
	
	//待ちヒメステータスを取得
	$thisState=$plugin->get_status($girl_sch->getItem('girlID'),$schData); ?>
	<li class="heightLine">
	<div class="cast_frame">
	<a href="<?php echo home_url('profile'); ?>?gid=<?php $girl_sch->echoItem('girlID');?>">
	<div class="cast_thumb">
	<?php if($options['cast_flag']['cast_flag_sch_icon'] == true){ ?><div class="cast_icon aligncenter"><img src="<?php bloginfo('template_directory'); ?>/images/icon0<?php echo $thisState;?>.jpg" /></div><?php } ?>
	<img src="<?php echo $imgPath."thumb.jpg"; ?>" alt="<?php $girl_sch->echoItem('name');?>" />
	</div>
	<div class="cast_section sub_color">
	<div class="cast_name"><?php $girl_sch->echoItem('name');?>(<?php $girl_sch->echoItem('age');?>)
    <?php if($options['cast_flag']['cast_flag_newface_icon'] == true){ ?>    
    <span class="newface_icon"><?php if($girl_sch->getItem('newface') == 1){ ?><img src="<?php bloginfo('stylesheet_directory'); ?>/images/ico_newface.gif" alt="NEW FACE" /><?php } ?></span>
    <?php } ?>
	</div>
	<div class="cast_size">T<?php $girl_sch->echoItem('height');?>B<?php $girl_sch->echoItem('B');?>(<?php $girl_sch->echoItem('cup');?>) W<?php $girl_sch->echoItem('W');?> H<?php $girl_sch->echoItem('H');?></div>
	<div class="cast_time"><?php $gc_sch->echo_scheduleShift($schData,",");?><?php $gc_sch->echo_scheduleTime($schData,"～");?></div>
	<p><?php $gc_sch->echo_scheduleText($schData);?></p>
	<div class="cast_comment"><?php $tmp=$gc_sch->get_onlyGirlData('一言コメント',false); echo $tmp->value;?></div>
	</div>
	</a>
	</div>
	</li>
	<?php
	endwhile;endif;
	$gc_sch->clear_girlsCollection();
	$schData=null;
	//$state=null;
	unset($schData);
	unset($state);
	/**END of スケジュール出力**/
	?>
	</ul>
    </div>
	<?php echo $after_widget; ?> 
	<?php
	}
	
	function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['height'] = strip_tags($new_instance['height']);
		
		return $instance;
	}
	
	function form($instance) {
	
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('出勤スケジュール');
	?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
		<p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('高さ'); ?></label></p>
		<p><input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($instance['height']); ?>" /></p>
	<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("scheduleItem");'));
?>