<?php 
class searchItem extends WP_Widget {

	function searchItem() {
		parent::WP_Widget(false, $name = 'CASTPRO -キャスト検索- ');
	}
		
	function widget($args, $instance) {
	
		extract($args);
		$title = apply_filters( 'widget_title', $instance['title'] );	
		$CASTPRO4_URI=get_option('castpro4_url');
		$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;		
		require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');
		global $CASTPRO,$options;
	?>
	<?php echo $before_widget; ?>
	<?php if($title){ echo $before_title.$title.$after_title; } ?>
    <div class="widget_frame">
    
    
    
    <?php
	 if(file_exists(get_stylesheet_directory().'/side_searchbox.inc')){ 
	 
	 	include(get_stylesheet_directory().'/side_searchbox.inc');
	 
	  }else{ ?>
    
	<form name="searchBox" action="<?php echo home_url('cast'); ?>" method="get">
	<!-- 身長 -->
	<div class="search_select_box">

	<select name="height">
	<option value="" <?php if(empty($_GET['height'])){ echo "selected=\"selected\""; } ?> >▼身長で検索</option>
	<option value="0<149" <?php if($_GET['height'] == '0<149'){ echo "selected=\"selected\""; } ?>>150cm以下</option>
	<option value="150<160"<?php if($_GET['height'] == '150<160'){ echo "selected=\"selected\""; } ?>>150cm～160cm</option>
	<option value="161<200" <?php if($_GET['height'] == '161<200'){ echo "selected=\"selected\""; } ?>>160cm以上</option>
	</select>
	
	
	<!-- 年齢 -->
	
	<select name="age">
	<option value="" selected="selected">▼年齢で検索</option>
	<option value="18<19">20歳以下</option>
	<option value="20<29">20歳～29歳</option>
	<option value="30<39">30歳～39歳</option>
	<option value="40<100">40歳以上</option>
	</select>
	

	
	<!-- バスト -->
	
	<select name="cup">
	<option value="" selected="selected">▼バストで検索</option>
	<option value="A<C">A～Cカップ</option>
	<option value="D<F">D～Fカップ</option>
	<option value="G<M">G～Mカップ</option>
	</select>

	<!-- アイコン -->
	
	
	<?php
    $thisList = $CASTPRO->get_paramList('アイコン');
    if(!empty($thisList)){
    ?>
   
    <select name="アイコン[]">
    <option value="">▼アイコンで検索</option>
    <?php foreach((array)$thisList as $value): ?>
    <option value="<?php echo $value['partsID'];?>" <?php selected($_GET['アイコン'][0],$value['partsID']); ?>><?php echo $value['value'];?></option>
    <?php if($_GET['アイコン'][0] == $value['partsID']){ $icon_set_param = $value['value']; } ?>
    <?php
     endforeach;
    ?>
    </select>
     <?php
    unset($thisList);
    unset($value);
    ?>


    
    <?php } ?>
    </div>
	<!-- タイプ -->
	<ul class="searchbox_lists field row">
	<?php
	$thisList=$CASTPRO->get_paramList('タイプ');
	foreach((array)$thisList as $value):
	?>
	<li><label class="checkbox<?php echo (isset($_GET['タイプ'])&&in_array($value['partsID'],$_GET['タイプ']))? " checked":""; ?>" for="type_<?php echo $value['partsID'];?>"><input name="タイプ[]" type="checkbox" value="<?php echo $value['partsID'];?>" id="type_<?php echo $value['partsID'];?>" style="display:none;" /><span></span><?php echo $value['value'];?></label></li>
	<?php
	endforeach;
	unset($thisList);
	unset($value);
	?>
	</ul>
<?php
		$thisList=$gc->shiftList;
	if(!empty($thisList)){	
	?>
	<ul class="searchbox_lists field row">
	<?php foreach((array)$thisList as $value): 	?>
	<li>
	<label class="radio <?php echo (isset($_GET['shift'])&&in_array($value['shiftTypeID'],explode(",",$_GET['shift'])))? "checked":""; ?>" for="<?php echo $value['shiftTypeID'];?>">
	<input name="shift" value="<?php echo $value['shiftTypeID'];?>" type="radio" id="<?php echo $value['shiftTypeID'];?>" style="display:none;" />
	<span></span><?php echo $value['label'];?>のみ
	</label>
	</li>
	<?php
		endforeach;
		unset($thisList);
		unset($value);
	?>
	</ul>
	<?php } ?>
	<div class="submit"><input type="submit" value="検索" class="btn <?php echo $options['button']; ?> <?php echo $options['button_type']; ?> submit" /></div>
	</form>
    
    <?php } ?>
 
	<?php echo $after_widget; ?> 
	<?php
	}
	
	function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		
		return $instance;
		
	}
	
	function form($instance) {
	
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('キャスト検索');
	?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
		<p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
	<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("searchItem");'));
?>