<?php 
class bannerItem extends WP_Widget {

	function bannerItem() {
	
    	parent::WP_Widget(false, $name = 'CASTPRO -バナー- ');
    }
	
    function widget($args, $instance) {
	
        extract( $args );
        $title = apply_filters( 'widget_title', $instance['title'] );
		$num = apply_filters( 'widget_title', $instance['num'] );
       	$CASTPRO4_URI=get_option('castpro4_url');
	    $CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;		
		require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');
	    $options = get_option( 'theme_options' );
        global $CASTPRO;
		global $gc;
    	?>
        <?php echo $before_widget; ?>
        <?php if($title){ echo $before_title.$title.$after_title; } ?>
        <?php echo $after_widget; ?> 
        <?php
    }
	
    function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['num'] = strip_tags($new_instance['num']);
        return $instance;
    }
	
    function form($instance) {
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($instance['title']); ?>" /></p>
          
        <p><label for="<?php echo $this->get_field_id('num'); ?>"><?php _e('表示人数'); ?></label></p>
        <p><input class="widefat" id="<?php echo $this->get_field_id('num'); ?>" name="<?php echo $this->get_field_name('num'); ?>" type="text" value="<?php echo esc_attr($instance['num']); ?>" /></p>
		<?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("bannerItem");'));
?>