<?php 
class waticastItem extends WP_Widget {

		function waticastItem() {
			parent::WP_Widget(false, $name = 'CASTPRO - 待ち姫 -');
		}
		
		function widget($args, $instance){
		
			extract($args);		
			$title = apply_filters( 'widget_title', $instance['title'] );		
			$CASTPRO4_URI=get_option('castpro4_url');		
			$CASTPRO4_URI=(strrpos($CASTPRO4_URI,'/',-1))? substr($CASTPRO4_URI,0,-1):$CASTPRO4_URI;
			require_once($_SERVER['DOCUMENT_ROOT'].'/'.$CASTPRO4_URI.'/viewer.config.inc');		
			$options = get_option( 'theme_options' );
			
			global $CASTPRO,$gc_wait,$plugin,$dateforShow,$CP_pluginList,$CP_SQL,$plugin;
			
			
	
		/*
		 * ウィジェット - 出勤
		 */
	
		//出力対象のステータス
		//1=待ちヒメ中、2=接客中、0=受付終了
		
		if(isset($_GET['state'])&&is_numeric($_GET['state'])){
		
			$target=array($_GET['state']);
			
		}else{
		
			$target = array(1);
		}
		
		
		$gc_wait = new girlsCollection($CP_SQL);
		$gc_wait->set_timeDiffAtDate($CASTPRO->get_property('dateShift')); //日付切り替え時間の指定
		
		$plugin=$CP_pluginList->getPluginByName('machihime');
		
		$gc_wait->set_order("workTime,schOrder");
		$gc_wait->get_girlsCollection("working=now&max=-1");
		$gc_wait->get_schedule("working=now");
		
		//待ちヒメ:現在のステータスを取得
		$plugin->set_status($gc_wait->get_girlsCollectionArr());
		$m_Count=0;
		
		foreach($target as $value){
		
			$m_Count += $plugin->get_statusNum($value);//待ちヒメの指定コード数をカウント
		}
	?>
	<?php echo $before_widget; ?>
	<?php if($title){ echo $before_title.$title.$after_title; } ?>
    <div class="widget_frame" <?php if($instance['height'] && wp_is_mobile() == false) echo "style=\"height:".$instance['height']."px; overflow-y:scroll;\""; ?>>
	<div class="clearfix">
	<div class="left"><?php echo date("m月d日 H時i分");?>現在</div><div class="right">待機中のキャスト:<span class="number text_pink"><?php echo $m_Count;?></span>名</div>
	</div>
	<ul id="top_schedule_list" class="cast_list_frame clearfix">
	<?php
	//空のスケジュールを用意
	$emptySchedule=new schedule_output();
	//キャストデータループ
	if($gc_wait->have_girls()):while($gc_wait->have_girls()):
	$girl_sch=new collection($gc_wait->the_girl());	//1人分のデータを取り出す
	
	$schData=$girl_sch->getItem('schedule');	//スケジュールデータを取り出す
	$schData=$schData[0]; //本日分のデータが入っている配列を取り出す
	if(empty($schData)) $schData=$emptySchedule;//スケジュールが無ければ空のスケジュールをセットする
	
	//画像のパスをセット
	$imgPath=sprintf($CASTPRO->get_property('girlsDataPath'),$girl_sch->getItem('girlID'));
	
	//待ちヒメステータスを取得
	$thisState=$plugin->get_status($girl_sch->getItem('girlID'),$schData);
	
	if(in_array($thisState,$target)): //待ちヒメ中
	?>
	<li class="heightLine">
	<div class="cast_frame">
	<a href="<?php echo home_url('profile'); ?>?gid=<?php $girl_sch->echoItem('girlID');?>">
	<div class="cast_thumb">
	<div class="cast_icon aligncenter"><img src="<?php bloginfo('template_directory'); ?>/images/icon0<?php echo $thisState;?>.jpg" /></div>
	<img src="<?php echo $imgPath."thumb.jpg"; ?>" alt="<?php $girl_sch->echoItem('name');?>" />
	</div>
	<div class="cast_section sub_color">
	<div class="cast_name"><?php $girl_sch->echoItem('name');?>(<?php $girl_sch->echoItem('age');?>) <span class="newface_icon"><?php if($girl_sch->getItem('newface') == 1){ ?><img src="<?php bloginfo('stylesheet_directory'); ?>/images/ico_newface.gif" alt="NEW FACE" /><?php } ?></span>
	</div>
	<div class="cast_size">T<?php $girl_sch->echoItem('height');?>B<?php $girl_sch->echoItem('B');?>(<?php $girl_sch->echoItem('cup');?>) W<?php $girl_sch->echoItem('W');?> H<?php $girl_sch->echoItem('H');?></div>
	<div class="cast_time">
	<p><?php $gc_wait->echo_scheduleTime($schData,"～");?></p>
    <p><?php $gc_wait->echo_scheduleShift($schData,",");?></p>
    </div>
	<p><?php $gc_wait->echo_scheduleText($schData);?></p>
	<div class="cast_comment"><?php $tmp=$gc_wait->get_onlyGirlData('一言コメント',false); echo $tmp->value;?></div>
	</div>
	</a>
	</div>
	</li>
	<?php
	endif; endwhile;
	else:
	
	endif;
	unset($tmp);
	
	$gc_wait->clear_girlsCollection();
	$schData=null;
	//$state=null;
	unset($schData);
	unset($state);
	/**END of スケジュール出力**/
	?>
	</ul>
    </div>
	<?php echo $after_widget; ?> 
	<?php
	}
	
	function update($new_instance, $old_instance) {
	
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['height'] = strip_tags($new_instance['height']);
		
		return $instance;
	}
	
	function form($instance) {
	
		// 初期値を設定 //
		$title = isset($instance['title']) ? $instance['title'] : __('待機中のキャスト');
	?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル'); ?></label></p>
		<p><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('高さ'); ?></label></p>
		<p><input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo esc_attr($instance['height']); ?>" /></p>
	<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("waticastItem");'));
?>